package org.ajax4jsf.test.base;



public class Templates {
	
	public static final String COMPONENT_PREFIX_INSIDE_TABLE = "_Selenium_Test_DataTable:0:";

	public static final String COMPONENT_PREFIX_SIMPLE = "";
	
	private String template = null;
	
	public Templates(String name) {
		template = name;
	}
	
	public static Templates SIMPLE = new Templates("simple"); 
	
	public static Templates DATATABLE = new Templates("dataTable");
	
	public static Templates MODALPANEL = new Templates("modalPanel");
	
	private void setParentId(SeleniumTestBase test) {
		if ("dataTable".equals(template)) {
			test.setParentId(COMPONENT_PREFIX_INSIDE_TABLE);
		} else {
			test.setParentId(COMPONENT_PREFIX_SIMPLE);
		}
	}
	
	public void loadTemplate(SeleniumTestBase test) {
		setParentId(test);
		test.runScript("loadTemplate('" + template + "');", false);
		test.waitForPageToLoad();
	}

	public boolean equals(Object obj) {
		if (obj == null || !(obj instanceof Templates)) {
			return false;
		}
		Templates template = (Templates) obj;
		if (template.template.equals(this.template)) {
			return true;
		}
		return false;
	}
	
	 
	
}
