package org.richfaces;

import org.ajax4jsf.test.base.RichSeleniumTest;
import org.ajax4jsf.test.base.SeleniumTestBase;
import org.ajax4jsf.test.base.Templates;
import org.testng.annotations.AfterTest;
import org.testng.annotations.BeforeTest;
import org.testng.annotations.Parameters;
import org.testng.annotations.Test;

public class AjaxCommandLinkTest extends SeleniumTestBase implements RichSeleniumTest {

    public AjaxCommandLinkTest() {
        super("http", "localhost", "8080");
    }
    
    /**
     * This method are invoking before selenium tests started
     */
    @BeforeTest
    @Parameters( { "browser" })
    public void startSelenium(String browser) {
    	super.startSelenium(browser);
    }
    
    /**
     * This method are invoking after selenium tests completed
     */
    @AfterTest
    public void stopSelenium() {
    	super.stopSelenium();
    }

    @Test
    public void testAjaxCommandLinkComponent() throws Exception {
    	_testAjaxCommandLinkComponent(Templates.SIMPLE);
    	_testAjaxCommandLinkComponent(Templates.DATATABLE);
    	_testAjaxCommandLinkComponent(Templates.MODALPANEL);
    }

    private void _testAjaxCommandLinkComponent(Templates template) {
    	renderPage(getTestUrl(), template);
    	    
     	String parentId = getParentId() + "_form:";
     
        String LinkId = parentId + "l1";
        String inputId = parentId + "_value";

        writeStatus("Click link 1 : ");
        clickById(LinkId);
        waitForAjaxCompletion();
        AssertValueEquals(inputId, "12345");

        writeStatus("Click link 1 again: ");
        clickById(LinkId);
        waitForAjaxCompletion();
        AssertValueEquals(inputId, "123452345");

        LinkId = parentId + "l2";

        writeStatus("Click link 2 : ");
        clickById(LinkId);
        waitForAjaxCompletion();
        AssertValueEquals(inputId, "1234523455");

        LinkId = parentId + "l3";

        writeStatus("Click link 3 : ");
        clickById(LinkId);
        waitForAjaxCompletion();
        AssertValueEquals(inputId, "1234523455");

        LinkId = parentId + "l4";

        writeStatus("Click link 4 : ");
        clickById(LinkId);
        waitForAjaxCompletion();
        AssertValueEquals(inputId, "12345234555");

        LinkId = parentId + "l5";

        writeStatus("Click link 5 : ");
        clickById(LinkId);
        waitForAjaxCompletion();
        AssertValueEquals(inputId, "12345234555");
     
    }

    public String getTestUrl() {
		return "/faces/pages/ajaxCommandLink/ajaxLinkTest.xhtml";
	}

}
